# coding=utf-8
"""
This code was generated by
\ / _    _  _|   _  _
 | (_)\/(_)(_|\/| |(/_  v1.0.0
      /       /       
"""

from twilio.domain import Domain
from twilio.rest.notifications.v1 import V1


class Notifications(Domain):

    def __init__(self, twilio):
        """
        Initialize the Notifications Domain
        
        :returns: Domain for Notifications
        :rtype: Notifications
        """
        super(Notifications, self).__init__(twilio)
        
        self.base_url = 'https://notifications.twilio.com'
        
        # Versions
        self._v1 = None

    @property
    def v1(self):
        """
        :returns: Version v1 of notifications
        :rtype: V1
        """
        if self._v1 is None:
            self._v1 = V1(self)
        return self._v1

    @property
    def credentials(self):
        """
        :rtype: CredentialList
        """
        return self.v1.credentials

    @property
    def services(self):
        """
        :rtype: ServiceList
        """
        return self.v1.services

    def __repr__(self):
        """
        Provide a friendly representation
        
        :returns: Machine friendly representation
        :rtype: str
        """
        return '<Twilio.Notifications>'
