# coding=utf-8
"""
This code was generated by
\ / _    _  _|   _  _
 | (_)\/(_)(_|\/| |(/_  v1.0.0
      /       /       
"""

from twilio.rest.preview.wireless.command import CommandList
from twilio.rest.preview.wireless.device import DeviceList
from twilio.rest.preview.wireless.rate_plan import RatePlanList
from twilio.version import Version


class Wireless(Version):

    def __init__(self, domain):
        """
        Initialize the Wireless version of Preview
        
        :returns: Wireless version of Preview
        :rtype: Wireless
        """
        super(Wireless, self).__init__(domain)
        self.version = 'wireless'
        self._commands = None
        self._devices = None
        self._rate_plans = None

    @property
    def commands(self):
        """
        :rtype: CommandList
        """
        if self._commands is None:
            self._commands = CommandList(self)
        return self._commands

    @property
    def devices(self):
        """
        :rtype: DeviceList
        """
        if self._devices is None:
            self._devices = DeviceList(self)
        return self._devices

    @property
    def rate_plans(self):
        """
        :rtype: RatePlanList
        """
        if self._rate_plans is None:
            self._rate_plans = RatePlanList(self)
        return self._rate_plans

    def __repr__(self):
        """
        Provide a friendly representation
        
        :returns: Machine friendly representation
        :rtype: str
        """
        return '<Twilio.Preview.Wireless>'
